﻿Type=Class
Version=3
@EndOfDesignText@
'Class module
#Event: Click
#Event: LongClick
#Event: ChangeCompleted

Sub Class_Globals

	Type TouchArgs(Action As Int, x As Float, y As Float)

   Private mTarget As Object
   Private mEventName As String
	
	Private pnlTextBack As Panel
	Private pnlTextFore As Panel
	Private lblDummy As Label
	
	Private mSliceW As Int
	Private mCnvText As Canvas
	Private mRecText, mRecBack As Rect
	Private X_CnvText, Y_CnvText As Float

	Private tmrText As Timer
	
#Region  + MEMBER VARIABLES 
'	Private mText As String
'	Private mTypeFace1 As Typeface
'	Private mTextSize As Float
	Private mAlign1 = "CENTER" As String
'	Private mAlign1 = "RIGHT" As String
'	Private mAlign1 = "LEFT" As String
'	Private mTextColor, mNewTextColor As Int
	Private mNewTextColor = Colors.Yellow As Int
	Private mColor = Colors.Transparent As Int
'	Private mColor = Colors.Blue As Int

' used for the transparent drawing
	Private mTextX0 As Int		' beginning position of the text
	Private mTextX1 As Int		' end position of the text
#End Region

End Sub

Public Sub Initialize (TargetModule As Object, EventName As String)
   mTarget = TargetModule
   mEventName = EventName
	
'	mTypeFace1 = Typeface.DEFAULT
'	mTextSize = 30
'	mAlign1 = "CENTER"
	
	tmrText.Initialize("tmrText", 50) ' TODO interval
	
	' TODO Calculate the mSliceW just for text width
	mSliceW = 2dip

End Sub


Public Sub DesignerCreateView(Base As Panel, lbl As Label, Props As Map)
	Base.Color = Colors.Transparent
	
	pnlTextBack = Base
	
	pnlTextFore.Initialize("pnlTextFore")
	Base.AddView(pnlTextFore, 0, 0, Base.Width, Base.Height)
	pnlTextFore.BringToFront
	
	lblDummy = lbl
	Base.AddView(lblDummy, 0, 0, Base.Width, Base.Height)
' assigning 'lblDummy = lbl' no need for the lines below
'	lblDummy.Text = lbl.Text
'	lblDummy.TextSize = lbl.TextSize
'	lblDummy.Typeface = lbl.Typeface
'	lblDummy.TextColor = lbl.TextColor
	lblDummy.Visible = False
	
' with  the lblDummy Label all properties are updated
'	mText = lbl.Text
'	mTextSize = lbl.TextSize
'	mTypeFace1 = lbl.Typeface
'	mTextColor = lbl.TextColor
	mNewTextColor = Colors.Yellow

	mRecText.Initialize(0, 0, mSliceW, pnlTextFore.Height)
	mRecBack.Initialize(0, 0, Base.Width, Base.Height)
	
	mCnvText.Initialize(pnlTextFore)
	
'	setColor(Colors.Transparent)
	DrawText
	
End Sub


#Region  + PROPERTIES 

#Region  Text 
Public Sub setText(Text As String)
	lblDummy.Text = Text
	DrawText
End Sub
Public Sub getText As String
	Return lblDummy.Text
End Sub
#End Region

#Region  TextSize 
Public Sub setTextSize(TextSize As Int)
	lblDummy.TextSize = TextSize
	DrawText
End Sub
Public Sub getTextSize As Int
	Return lblDummy.TextSize
End Sub
#End Region

#Region  TypeFace1 
Public Sub setTypeFace1(TypeFace1 As Typeface)
	lblDummy.Typeface = TypeFace1
	DrawText
End Sub

Public Sub getTypeFace1 As Typeface
	Return lblDummy.Typeface
End Sub
#End Region

Public Sub setWidth(Width As Int)
	pnlTextBack.Width = Width
	pnlTextFore.Width = Width
	DrawText
End Sub

Public Sub getWidth As Int
	Return pnlTextBack.Width
End Sub

#Region  Align1 
Public Sub setAlign1(Align1 As String)
	mAlign1 = Align1
	DrawText
End Sub

Public Sub getAlign1 As String
	Return mAlign1
End Sub
#End Region

#Region  Text Color 
Public Sub setTextColor(TextColor As Int)
	lblDummy.TextColor = TextColor
	DrawText
End Sub
Public Sub getTextColor As Int
	Return lblDummy.TextColor
End Sub
#End Region

#Region  New Text Color 
Public Sub setNewTextColor(NewTextColor As Int)
	mNewTextColor = NewTextColor
	DrawText
End Sub
Public Sub getNewTextColor As Int
	Return mNewTextColor
End Sub
#End Region

#Region  Color 
Public Sub setColor(Color As Int)
	mColor = Color
	DrawText
End Sub
Public Sub getColor As Int
	Return mColor
End Sub
#End Region



Public Sub GetPanel As Panel
	Return pnlTextBack
End Sub

#End Region


#Region  + PUBLIC METHODS 

Public Sub StartChange
	mRecText.Left = 0
	pnlTextFore.Visible = True
	tmrText.Enabled = True
	DrawText
End Sub

#End Region


#Region  + RAISED EVENTS 

Private Sub ChangeCompleted
	If SubExists(mTarget, mEventName & "_ChangeCompleted") Then
		CallSub(mTarget, mEventName & "_ChangeCompleted")
	End If
End Sub

Private Sub pnlTextBack_Click
	If SubExists(mTarget, mEventName & "_Click") Then
		CallSub(mTarget, mEventName & "_Click")
	End If
End Sub

Private Sub pnlTextBack_LongClick
	If SubExists(mTarget, mEventName & "_LongClick") Then
		CallSub(mTarget, mEventName & "_LongClick")
	End If
End Sub

#End Region

	
#Region  + PRIVATE METHODS 

Private Sub DrawText
'Log("pnlTextFore w,h: " & pnlTextFore.Width & "," & pnlTextFore.Height)
'Log("pnlTextBack w,h: " & pnlTextBack.Width & "," & pnlTextBack.Height)
	mRecBack.Initialize(0, 0, pnlTextFore.Width, pnlTextFore.Height)
'	X_CnvText = 50 : Y_CnvText = 50
	Select mAlign1
	Case "LEFT"
		X_CnvText = 0
		mTextX0 = 0
		mTextX1 = mCnvText.MeasureStringWidth(lblDummy.Text, lblDummy.Typeface, lblDummy.TextSize)
	Case "CENTER"
		X_CnvText = pnlTextBack.Width / 2
		mTextX0 = (pnlTextFore.Width - mCnvText.MeasureStringWidth(lblDummy.Text, lblDummy.Typeface, lblDummy.TextSize)) / 2
		mTextX1 = mTextX0 + mCnvText.MeasureStringWidth(lblDummy.Text, lblDummy.Typeface, lblDummy.TextSize)
	Case "RIGHT"
		X_CnvText = pnlTextBack.Width
		mTextX0 = pnlTextBack.Width - mCnvText.MeasureStringWidth(lblDummy.Text, lblDummy.Typeface, lblDummy.TextSize)
		mTextX1 = pnlTextBack.Width
	End Select
	
	' This calculates the text centered vertically 
	Y_CnvText = (pnlTextBack.Height + mCnvText.MeasureStringHeight(lblDummy.Text, lblDummy.Typeface, lblDummy.TextSize)) / 2
	
	mCnvText.Initialize(pnlTextBack)
	mCnvText.DrawRect(mRecBack, mColor, True, 1)	' erase previous text needed after scaling
	mCnvText.DrawText(lblDummy.Text, X_CnvText, Y_CnvText, lblDummy.Typeface, lblDummy.TextSize, lblDummy.TextColor, mAlign1)

	mCnvText.Initialize(pnlTextFore)
	mCnvText.DrawRect(mRecBack, mColor, True, 1)	' erase previous text
	mCnvText.DrawText(lblDummy.Text, X_CnvText, Y_CnvText, lblDummy.Typeface, lblDummy.TextSize, mNewTextColor, mAlign1)

	mRecText.Left = mTextX0
	mRecText.Bottom = pnlTextFore.Height
End Sub

#End Region


#Region  + EVENTS 

Sub tmrText_Tick
	mCnvText.DrawRect(mRecText, Colors.Transparent, True, 0)
	pnlTextFore.Invalidate
'	DoEvents	' not needed !
	mRecText.Left = mRecText.Left + mSliceW
	If mRecText.Left >= mTextX1 Then
		tmrText.Enabled = False
		pnlTextFore.Visible = False
		ChangeCompleted
		DrawText
	End If
End Sub

#End Region

